<div class="opened-projects-list mb-5">
  <div class="container">

    <div class="search-div">

      <ng-container *ngIf="currentUser?.permissions?.canEditProjects">
        <button mat-raised-button (click)="onCreateProjectDialog()">
          <mat-icon>add</mat-icon>
          Załóż nowy projekt
        </button>
      </ng-container>

      <mat-form-field class="search-form-field">
        <input matInput [(ngModel)]="searchKey" placeholder="Wyszukaj projekt po jego nazwie" autocomplete="off"
               (keyup)="applyFilter()">
        <button mat-button matSuffix mat-icon-button aria-label="Wyczyść" *ngIf="searchKey" (click)="onSearchClear()">
          <mat-icon>close</mat-icon>
        </button>
      </mat-form-field>
    </div>

    <div class="mat-elevation-z8">
      <mat-table mat-table [dataSource]="openedProjectsDataSource" matSort>

        <ng-container matColumnDef="name">
          <mat-header-cell mat-header-cell *matHeaderCellDef mat-sort-header> Nazwa projektu</mat-header-cell>
          <mat-cell mat-cell *matCellDef="let element"> {{element?.name}} </mat-cell>
        </ng-container>

        <ng-container matColumnDef="code">
          <mat-header-cell mat-header-cell *matHeaderCellDef mat-sort-header> Kod projektu</mat-header-cell>
          <mat-cell mat-cell *matCellDef="let element"> {{element?.code}} </mat-cell>
        </ng-container>

        <ng-container matColumnDef="client">
          <mat-header-cell mat-header-cell *matHeaderCellDef mat-sort-header> Klient</mat-header-cell>
          <mat-cell mat-cell
                    *matCellDef="let element"> {{element?.client?.name ? element?.client?.name : '--Projekt wewnętrzny--'}} </mat-cell>
        </ng-container>

        <ng-container matColumnDef="projectManager">
          <mat-header-cell mat-header-cell *matHeaderCellDef mat-sort-header> Kierownik projektu</mat-header-cell>
          <mat-cell mat-cell
                    *matCellDef="let element"> {{element?.manager?.data?.firstName}} {{element?.manager?.data?.lastName}} </mat-cell>
        </ng-container>

        <ng-container matColumnDef="startDate">
          <mat-header-cell mat-header-cell *matHeaderCellDef mat-sort-header> Data rozpoczęcia</mat-header-cell>
          <mat-cell mat-cell *matCellDef="let element"> {{element?.startDate | date: 'd/MM/yyyy' }} </mat-cell>
        </ng-container>

        <ng-container matColumnDef="plannedEndDate">
          <mat-header-cell mat-header-cell *matHeaderCellDef mat-sort-header> Planowana data zakończenia
          </mat-header-cell>
          <mat-cell mat-cell *matCellDef="let element"> {{element?.plannedEndDate | date: 'd/MM/yyyy'}} </mat-cell>
        </ng-container>

        <ng-container matColumnDef="plannedBudget">
          <mat-header-cell mat-header-cell *matHeaderCellDef mat-sort-header> Planowany budżet</mat-header-cell>
          <mat-cell mat-cell
                    *matCellDef="let element"> {{element?.plannedBudget | currency: 'PLN':'symbol':'':'pl'}} </mat-cell>
        </ng-container>

        <ng-container matColumnDef="plannedIncome">
          <mat-header-cell mat-header-cell *matHeaderCellDef mat-sort-header> Planowany przychód</mat-header-cell>
          <mat-cell mat-cell
                    *matCellDef="let element"> {{element?.plannedIncome | currency: 'PLN':'symbol':'':'pl'}} </mat-cell>
        </ng-container>

        <ng-container matColumnDef="actions">
          <mat-header-cell *matHeaderCellDef></mat-header-cell>
          <mat-cell *matCellDef="let row">
            <ng-container *ngIf="currentUser?.permissions?.canEditProjects">
              <button mat-icon-button (click)="onUpdateProjectDialog(row)">
                <mat-icon matTooltip="Edytuj projekt">edit</mat-icon>
              </button>
              <button mat-icon-button color="primary" (click)="onCloseProject(row)">
                <mat-icon matTooltip="Zamknij projekt">close</mat-icon>
              </button>
              <a mat-icon-button color="accent" [routerLink]="['/company/projects/', row.id]">
                <mat-icon matTooltip="Pokaż szczegóły projektu">arrow_forward</mat-icon>
              </a>
            </ng-container>
          </mat-cell>
        </ng-container>

        <ng-container matColumnDef="loading">
          <mat-footer-cell *matFooterCellDef>
            Ładowanie danych...
          </mat-footer-cell>
        </ng-container>
        <ng-container matColumnDef="noData">
          <mat-footer-cell *matFooterCellDef>
            Aktualnie nie ma danych o otwartych projektach w Twojej firmie.
          </mat-footer-cell>
        </ng-container>

        <mat-header-row mat-header-row *matHeaderRowDef="displayedColumns"></mat-header-row>
        <mat-row mat-row *matRowDef="let row; columns: displayedColumns;"></mat-row>

        <mat-footer-row *matFooterRowDef="['loading']"
                        [ngClass]="{'none':openedProjectsDataSource!=null}"></mat-footer-row>
        <mat-footer-row *matFooterRowDef="['noData']"
                        [ngClass]="{'none':!(openedProjectsDataSource!=null && openedProjectsDataSource.data.length==0)}"></mat-footer-row>
      </mat-table>

      <mat-paginator [pageSizeOptions]="[5, 10, 25, 100]" [pageSize]="10" showFirstLastButtons></mat-paginator>
    </div>
  </div>
</div>
